@ECHO OFF
ECHO OFF
GOTO Begin
REM
REM     Program          :  LoopOn.bat
REM
REM     Version          :  2.03
REM     Started on       :  November 24, 2007
REM     Completed on     :  November 24, 2007
REM
REM     Description      :  Loops a program on files in a directory
REM
REM     Required modules :  LoopOCfg,bat, FileUtil.bat, StrUtil.bat, StrTrim.exe,
REM							StrComp.exe, StrKeep.exe, StrAlign.exe, Wc.exe
REM     Dos required     :  Dos 6.0 or later
REM
REM     Notes - usage    :  See help (/? parameter)
REM     References       :  None
REM
REM     Authors          :  J.Hubb - planning
REM                         J.Hubb - programming
REM                         J.Hubb - debug session
REM     Authors address  :  J.Hubb
REM                         Indigo skyline
REM                         A'DAAR channel
REM

:Begin
IF "%DEBUG%" == "Y" ECHO ON
IF "%1" == "[]ENVPREPARED[]" GOTO Start
%COMSPEC% /E:4096 /C %0 []ENVPREPARED[] %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO End

:Start
SET NAME=%0
SHIFT
ECHO.
ECHO LoopOn.bat 2.03; freeware on November 24, 2007 by J.Hubb.

:ChkHelp
IF "%1" == "/?" GOTO Help
IF "%2" == "" GOTO Help

:LoadCfg
SET LO_DATECMD=
IF EXIST %NAME%\..\LoopOCfg.bat CALL %NAME%\..\LoopOCfg.bat
IF NOT "%LO_DATECMD%" == "" GOTO EndLC
CALL LoopOCfg.bat
IF "%LO_DATECMD%" == "" GOTO NoCfgErr
:EndLC

:ChkLib
SET LO_TMP=
CALL StrUtil Ver LO_TMP
IF "%LO_TMP%" == "" GOTO NoStrUtilErr
SET LO_TMP=
CALL FileUtil Ver LO_TMP
IF "%LO_TMP%" == "" GOTO NoFileUtilErr

:CreateTmpFiles
CALL FileUtil NewFileName %TMP% LO tmp LO_TMP1
SET LO_TMP2=%LO_TMP1%2> %TMP%\%LO_TMP1%2.tmp

:ChkPath
SET LO_PATH=%1
ECHO %LO_PATH%| STRTRIM "$22" ALL > %TMP%\%LO_TMP1%.tmp
CALL StrUtil Str2Env %TMP%\%LO_TMP1%.tmp LO_PATH
ECHO %LO_PATH%| STRTRIM "\" RIGHT | STRCOMP "=" "%LO_PATH%" > NUL
IF ERRORLEVEL 1 GOTO IsDir
IF NOT EXIST %LO_PATH%\NUL GOTO IsFile
SET LO_PATH=%LO_PATH%\
GOTO IsDir

:IsDir
SET LO_TYPE=directory
GOTO ChkSysHid

:IsFile
SET LO_TYPE=group of files
GOTO ChkSysHid

:ChkSysHid
SET LO_ALL=
IF NOT "%2" == "/A" IF NOT "%2" == "/a" GOTO EndCSH
SET LO_ALL=/A
SHIFT
:EndCSH

:ChkInfo
SET LO_INFO=
IF NOT "%2" == "/I" IF NOT "%2" == "/i" GOTO EndCI
SET LO_INFO=Y
SHIFT
:EndCI

:ReadPath
SET LO_COUNT=1234567890> %TMP%\%LO_TMP1%.tmp
IF EXIST %LO_PATH% DIR %LO_ALL% /B /-P %LO_PATH% > %TMP%\%LO_TMP1%.tmp
WC -l < %TMP%\%LO_TMP1%.tmp | STRTRIM " " ALL > %TMP%\%LO_TMP2%.tmp
CALL StrUtil Str2Env %TMP%\%LO_TMP2%.tmp LO_COUNT
SET LO_DIR=%LO_PATH%
ECHO %LO_PATH%| STRKEEP BEFORE "\" INCLUDED FROM -1 > %TMP%\%LO_TMP2%.tmp
CALL StrUtil Str2Env %TMP%\%LO_TMP2%.tmp LO_DIR

:InitLoop
SHIFT
SHIFT
CALL FileUtil ReadTextRow Open %TMP%\%LO_TMP1%.tmp LO_STAT
ECHO.
ECHO Repeated command: %0 {FilePath} %1 %2 %3 %4 %5 %6 %7 %8 %9
ECHO Specified path:   %LO_PATH%
ECHO Type of path:     %LO_TYPE%
ECHO Repeated on:      %LO_COUNT% files
IF "%LO_ALL%" == "" ECHO Sys/Hid included: no
IF NOT "%LO_ALL%" == "" ECHO Sys/Hid included: yes
ECHO.
%LO_DATECMD% "+--- LoopOn.bat - Start: %%X - %%a, %%d %%b %%y " | STRALIGN "-" 60 LEFT

:Process1File
SET LO_TMP=12345678901234567890123456789012345678901234567890123456789012345678901234567890
SET LO_TMP=%LO_TMP%12345678901234567890123456789012345678901234567890123456789012345678901234567890
SET LO_TMP=%LO_TMP%12345678901234567890123456789012345678901234567890123456789012345678901234567890
CALL FileUtil ReadTextRow Next %LO_STAT% LO_TMP
IF "%LO_STAT%" == "EOF" GOTO ProcessEnded
IF "%LO_INFO%" == "Y" ECHO --- LoopOn.bat - File: "%LO_DIR%%LO_TMP%"
%COMSPEC% /C %0 "%LO_DIR%%LO_TMP%" %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO Process1File

:ProcessEnded
%LO_DATECMD% "+--- LoopOn.bat - End: %%X - %%a, %%d %%b %%y " | STRALIGN "-" 60 LEFT
CALL FileUtil ReadTextRow Close %LO_STAT%
ECHO.
GOTO End

:NotFound
ECHO Error: path "%1" not found. Aborted.
ECHO.
GOTO End

:NoCfgErr
ECHO.
ECHO Error: configuration file "LoopOCfg.bat" not found or not correct.
ECHO Execution aborted.
GOTO End

:NoStrUtilErr
ECHO.
ECHO Error: library "StrUtil.bat" not found.
ECHO Execution aborted.
GOTO End

:NoFileUtilErr
ECHO.
ECHO Error: library "FileUtil.bat" not found.
ECHO Execution aborted.
GOTO End

:Help
ECHO.
ECHO Syntax:
ECHO   LOOPON {Path} [/A] [/I] {ProgToBeRepeated} [ProgParameters]
ECHO.
ECHO Repeats the program {ProgToBeRepeated} on every entry of specified
ECHO {Path} (also with wildcards),  passing to it the complete pathname
ECHO of current file as first parameter and parameters [ProgParameters]
ECHO as  following ones.  If [/A] is used, system and hidden  files are
ECHO included in processing; if [/I] is used, some info on current file
ECHO is printed. LoopOn can be nested.
ECHO.
GOTO End

:End
IF EXIST %TMP%\%LO_TMP1%.tmp DEL %TMP%\%LO_TMP1%.tmp
IF EXIST %TMP%\%LO_TMP2%.tmp DEL %TMP%\%LO_TMP2%.tmp
